"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.read = void 0;
var prompt = require("prompt");
prompt.delimiter = "";
prompt.message = "> ";
var queue = [];
// This is the read lib that uses Q instead of callbacks.
function read(name, message, silent, promptDefault) {
    if (silent === void 0) { silent = false; }
    var promise = new Promise(function (resolve, reject) {
        var schema = {
            properties: {},
        };
        schema.properties[name] = {
            hidden: silent,
        };
        if (typeof promptDefault === "undefined") {
            schema.properties[name].required = true;
            schema.properties[name].description = message + ":";
        }
        else {
            schema.properties[name].description = message + " (default = " + promptDefault + ")" + ":";
        }
        Promise.all(queue.filter(function (x) { return x !== promise; })).then(function () {
            prompt.start();
            prompt.get(schema, function (err, result) {
                if (err) {
                    reject(err);
                }
                else {
                    if (!result || !result[name] || !result[name].trim || !result[name].trim()) {
                        resolve(promptDefault);
                    }
                    else {
                        resolve(result[name]);
                    }
                }
                queue.shift();
            });
        });
    });
    queue.unshift(promise);
    return promise;
}
exports.read = read;
//# sourceMappingURL=qread.js.map